package org.beginningee6.tutorial;

import javax.annotation.ManagedBean;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.interceptor.Interceptors;
import java.util.Random;
import java.util.logging.Logger;

/**
 * @author Antonio Goncalves & Alexis Moussine-Pouchkine
 *         Tutorial - Beginning with The Java EE 6 Platform
 *         http://www.antoniogoncalves.org
 *         http://blogs.sun.com/alexismp
 *         --
 *         Simple IsbnGenerator Pojo with Managed Bean annotation
 */
@ManagedBean
public class IsbnGenerator {

    // ======================================
    // =             Attributes             =
    // ======================================

    private Logger logger = Logger.getLogger("org.beginningee6.tutorial");

    // ======================================
    // =          Lifecycle methods         =
    // ======================================

    @PostConstruct
    private void init() {
        logger.info("=====> PostConstruct");
    }

    @PreDestroy
    private void release() {
        logger.info("=====> PreDestroy");
    }

    // ======================================
    // =          Business methods          =
    // ======================================

    @Interceptors(LoggingInterceptor.class)
    public String generateIsbn() {
        return "1-84356-" + Math.abs(new Random().nextInt());
    }
}