package org.beginningee6.tutorial;

import javax.enterprise.event.Event;
import javax.enterprise.inject.Alternative;
import javax.inject.Inject;

/**
 * @author Antonio Goncalves & Alexis Moussine-Pouchkine
 *         Tutorial - Beginning with The Java EE 6 Platform
 *         http://www.antoniogoncalves.org
 *         http://blogs.sun.com/alexismp
 *         --
 *         A special implementation of the Customer interface with a CDI Qualifier (Premium)
 */
//@Premium
@Alternative
public class SpecialCustomer implements Customer {

    // ======================================
    // =             Attributes             =
    // ======================================

    @Inject
    @ImportantOrder
    Event<OrderItem> order;

    // ======================================
    // =          Business methods          =
    // ======================================

    @Override
    public OrderItem buy(String isbn) {
        OrderItem theOrder = new OrderItem(isbn);
        order.fire(theOrder);  // will be caught by any method declaring an "@Observes Order" parameter.
        return theOrder;
    }

    @Override
    public boolean canBuy() {
        return true;
    }
}
