/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.beginningee6.tutorial.order;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import javax.inject.Qualifier;

/**
 * 決済
 *
 * @author tezu36
 */
// 限定子(@Qualifier)は、インジェクションの依存関係を決定するために使用するアノーテーションベースのメタデータ定義です。
// https://blogs.oracle.com/nishigaya/entry/javaee6_understanding_cdi_part_2
// → インジェクションをする・される、両方で共通に使用するアノテージョンが使用する必要有りか 
@Qualifier
@Target({ElementType.METHOD,ElementType.FIELD, ElementType.PARAMETER,ElementType.TYPE})
// 実行する際にもJavaVMにそのアノテーションの情報が読み込まれる。リフレクションを用いてその情報を取得することが出来る。
// http://www.ne.jp/asahi/hishidama/home/tech/java/annotation.html
@Retention(RetentionPolicy.RUNTIME)
public @interface SettlementMark {
}
